<?php
/**
 * @package     Joomla.Libraries
 * @subpackage  Toolbar
 *
 * @copyright   Copyright (C) 2005 - 2014 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE
 */

defined('JPATH_PLATFORM') or die;

/**
 * Renders a custom button
 *
 * @package     Joomla.Libraries
 * @subpackage  Toolbar
 * @since       3.0
 */
class JToolbarButtonCrbcdivider extends JToolbarButton
{
	/**
	 * Button type
	 *
	 * @var    string
	 */
	protected $_name = 'Crbcdivider';

	/**
	 * Fetch the HTML for the button
	 *
	 * @param   string  $type  Button type, unused string.
	 * @param   string  $html  HTML strng for the button
	 * @param   string  $id    CSS id for the button
	 *
	 * @return  string   HTML string for the button
	 *
	 * @since   3.0
	 */
	public function fetchButton($type = 'Crbcdivider', $html = '', $id = 'crbcdivider')
	{
            JFactory::getDocument()->addStyleDeclaration('.crbc-divider{ position: absolute; top: 0; display: inline-block; height: 57px; border-left: 1px solid lightgrey; }');
            JFactory::getDocument()->addStyleDeclaration('.crbc-divider2{ position: absolute; top: 0; display: inline-block; height: 57px; border-left: 1px solid white; }');
            JFactory::getDocument()->addStyleDeclaration('.crbc-divider-margin-left{ margin-left: 10px;}');
            return '<div class="crbc-divider-margin-left"></div><div class="crbc-divider"><div class="crbc-divider2"></div></div>';
	}

	/**
	 * Get the button CSS Id
	 *
	 * @param   string  $type  Not used.
	 * @param   string  $html  Not used.
	 * @param   string  $id    The id prefix for the button.
	 *
	 * @return  string  Button CSS Id
	 *
	 * @since   3.0
	 */
	public function fetchId($type = 'Crbcdivider', $html = '', $id = 'crbcdivider')
	{
		return $this->_parent->getName() . '-' . $id;
	}
}
