<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// No direct access
defined('_JEXEC') or die('Restricted access');

$libpath = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce' . DS . 'classes' . DS . 'plugin' . DS;
require_once($libpath . 'CrBcSitePlugin.php');

abstract class CrBcAProductdetailsAdminPlugin extends CrBcAdminPlugin{
               
    function __construct() {
        parent::__construct();
    }
    
    /**
     * Can be used to handle the outcome of order item infos for certain aspects of the order item display.
     * Order item infos are usually set within product display plugins on the client:site.
     * However, they may be done through CrBcCart::addOrderInfo() anwywhere.
     * 
     * @param array $order_item_info containing all order item infos (plural) for an (one) order item. 
     * @param string $view can be either 'order' (default), 'cart', 'text_invoice' or 'html_invoice'
     * @return array the altered $order_item_info array which MUST be returned, otherwise it might destory other plugin's output.
     */
    function handleOrderItemDisplay($order_item_info, $view = 'order'){
        
        return $order_item_info;
    }
}