<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// No direct access
defined('_JEXEC') or die('Restricted access');

$libpath = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce' . DS . 'classes' . DS . 'plugin' . DS;
require_once($libpath . 'CrBcProductdetailsPlugin.php');

interface CrBcProductdetailsSitePlugin extends CrBcProductdetailsPlugin{
    
    /**
     * Should return a string with the information stored for the product_id/combination_id.
     *
     * Will be rendered in product details, orders, invoices, memos and so on.
     *
     * Return an empty string if you don't want to use it.
     *
     * @param int $product_id
     * @param int $combination_id
     * @return string
     */
    public static function getInfo($product_id, $combination_id);
    /**
     * Displaying info in that location.
     * Leave empty, so BreezingCommerce omits it
     * 
     * @param string $info
     */
    public static function infoBeforePrice($info);
    /**
     * Displaying info in that location.
     * Leave empty, so BreezingCommerce omits it
     * 
     * @param string $info
     */
    public static function infoAfterPrice($info);
    /**
     * Displaying info in that location.
     * Leave empty, so BreezingCommerce omits it
     * 
     * @param string $info
     */
    public static function infoBeforeDescription($info);
    /**
     * Displaying info in that location.
     * Leave empty, so BreezingCommerce omits it
     * 
     * @param string $info
     */
    public static function infoAfterDescription($info);
    /**
     * Displaying info in that location.
     * For example in product tabs.
     * Leave empty, so BreezingCommerce omits it
     * 
     * @param string $info
     */
    public static function infoInsideFooter($info);
}