<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// no direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');

class BreezingcommerceControllerPlugins extends JControllerLegacy
{
    function __construct()
    {
        parent::__construct();
        // Register Extra tasks
        $this->registerTask( 'add', 'edit' );
    }

    function plugin_orderup() {
        $cids = JRequest::getVar('cid', array(), '', 'array');
        JArrayHelper::toInteger($cids);
        if(isset($cids[count($cids)-1])){
            $model = $this->getModel( 'plugin' );
            $data = $model->getPluginData($cids[count($cids)-1]);
            $plugin = $model->getPlugin($data);
            $plugin->move(-1, $cids[0]);
            $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=plugins&task=edit&cid[]='.$cids[count($cids)-1].'&limitstart='.JRequest::getInt('limitstart') );
        }
    }

    function plugin_orderdown() {
        $cids = JRequest::getVar('cid', array(), '', 'array');
        JArrayHelper::toInteger($cids);
        if(isset($cids[count($cids)-1])){
            $model = $this->getModel( 'plugin' );
            $data = $model->getPluginData($cids[count($cids)-1]);
            $plugin = $model->getPlugin($data);
            $plugin->move(1, $cids[0]);
            $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=plugins&task=edit&cid[]='.$cids[count($cids)-1].'&limitstart='.JRequest::getInt('limitstart') );
        }
    }

    function plugin_publish() {
        $cids = JRequest::getVar('cid', array(), '', 'array');
        JArrayHelper::toInteger($cids);
        if(isset($cids[count($cids)-1])){
            $model = $this->getModel( 'plugin' );
            $data = $model->getPluginData($cids[count($cids)-1]);
            $plugin = $model->getPlugin($data);
            $ids = $cids;
            unset($ids[count($ids)-1]);
            $plugin->setPublished($ids);
            $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=plugins&task=edit&cid[]='.$cids[count($cids)-1].'&limitstart='.JRequest::getInt('limitstart') );
        }
    }

    function plugin_unpublish() {
        $cids = JRequest::getVar('cid', array(), '', 'array');
        JArrayHelper::toInteger($cids);
        if(isset($cids[count($cids)-1])){
            $model = $this->getModel( 'plugin' );
            $data = $model->getPluginData($cids[count($cids)-1]);
            $plugin = $model->getPlugin($data);
            $ids = $cids;
            unset($ids[count($ids)-1]);
            $plugin->setUnpublished($ids);
            $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=plugins&task=edit&cid[]='.$cids[count($cids)-1].'&limitstart='.JRequest::getInt('limitstart') );
        }
    }

    function plugin_saveorder(){
        $cids = JRequest::getVar('cid', array(), '', 'array');
        JArrayHelper::toInteger($cids);
        if(isset($cids[count($cids)-1])){
            $model = $this->getModel( 'plugin' );
            $data = $model->getPluginData($cids[count($cids)-1]);
            $plugin = $model->getPlugin($data);
            $ids = $cids;
            unset($ids[count($ids)-1]);
            $order = JRequest::getVar( 'order', array(), 'post', 'array' );
            $plugin->saveOrder($ids, $order);
            $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=plugins&task=edit&cid[]='.$cids[count($cids)-1].'&limitstart='.JRequest::getInt('limitstart') );
        }
    }

    function plugin_remove()
    {
        $cids = JRequest::getVar('cid', array(), '', 'array');
        JArrayHelper::toInteger($cids);
        if(isset($cids[count($cids)-1])){
            $model = $this->getModel( 'plugin' );
            $data = $model->getPluginData($cids[count($cids)-1]);
            $plugin = $model->getPlugin($data);
            $ids = $cids;
            unset($ids[count($ids)-1]);
            $plugin->delete($ids);
            $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=plugins&task=edit&cid[]='.$cids[count($cids)-1].'&limitstart='.JRequest::getInt('limitstart') );
        }
    }

    function plugin_cancel()
    {
        $cids = JRequest::getVar('cid', array(), '', 'array');
        JArrayHelper::toInteger($cids);
        if(isset($cids[count($cids)-1])){
            $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=plugins&task=edit&cid[]='.$cids[count($cids)-1].'&limitstart='.JRequest::getInt('limitstart') );
        }
    }

    function plugin_add()
    {
        $cids = JRequest::getVar('cid', array(), '', 'array');
        JArrayHelper::toInteger($cids);
        if(isset($cids[count($cids)-1])){
            $model = $this->getModel( 'plugin' );
            $data = $model->getPluginData($cids[count($cids)-1]);
            $plugin = $model->getPlugin($data);
            $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=plugins&task=edit&cid[]='.$cids[count($cids)-1].'&plugin_view='.$plugin->detail_view.'&identity='.JRequest::getVar($plugin->identity_column, '0').'&limitstart='.JRequest::getInt('limitstart') );
        }
    }

    function plugin_apply()
    {
        $msg = JText::_('Item(s) stored');
        $cids = JRequest::getVar('cid', array(), '', 'array');
        JArrayHelper::toInteger($cids);
        if(isset($cids[count($cids)-1])){
            $model = $this->getModel( 'plugin' );
            $data = $model->getPluginData($cids[count($cids)-1]);
            $plugin = $model->getPlugin($data);
            $data = $plugin->store();
            
            if($data[$plugin->identity_column]){
                $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=plugins&task=edit&cid[]='.$cids[count($cids)-1].'&plugin_view='.$plugin->detail_view.'&identity='.$data[$plugin->identity_column].'&limitstart='.JRequest::getInt('limitstart'),$msg );
            }
            else{
                $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=plugins&task=edit&cid[]='.$cids[count($cids)-1].'&limitstart='.JRequest::getInt('limitstart'),$msg );
            }
        }
    }

    function plugin_save()
    {
        $msg = JText::_('Item(s) stored');
        $cids = JRequest::getVar('cid', array(), '', 'array');
        JArrayHelper::toInteger($cids);
        if(isset($cids[count($cids)-1])){
            $model = $this->getModel( 'plugin' );
            $data = $model->getPluginData($cids[count($cids)-1]);
            $plugin = $model->getPlugin($data);
            $plugin->store();
            $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=plugins&task=edit&cid[]='.$cids[count($cids)-1].'&limitstart='.JRequest::getInt('limitstart'),$msg );
        }
    }

    function install(){
        JRequest::setVar( 'view', 'plugin' );
        JRequest::setVar( 'layout', 'install'  );
        JRequest::setVar( 'hidemainmenu', 1 );

        parent::display();
    }

    function perform_install(){

        jimport('joomla.filesystem.folder');
        jimport('joomla.filesystem.file');
        jimport('joomla.installer.installer');
        jimport('joomla.installer.helper');
        jimport('joomla.filesystem.archive');

        $result = false;
        $extractdir = '';

        $userfile = JRequest::getVar('install_package', null, 'files', 'array' );

        if (is_array($userfile) ) {
            // Get the uploaded file information
            $userfile = JRequest::getVar('install_package', null, 'files', 'array' );

            // Make sure that file uploads are enabled in php
            if (!(bool) ini_get('file_uploads')) {
                JError::raiseWarning(503, JText::_('Warninstallfile'));
                return false;
            }

            // Make sure that zlib is loaded so that the package can be unpacked
            if (!extension_loaded('zlib')) {
                JError::raiseWarning(503, JText::_('Warninstallzlib'));
                return false;
            }


            // Check if there was a problem uploading the file.
            if ( $userfile['error'] || $userfile['size'] < 1 ) {
                JError::raiseWarning(503, JText::_('Warninstalluploadererror'));
                return false;
            }

            // Build the appropriate paths
            $config = JFactory::getConfig();
            $tmp_dest 	= $config->get('tmp_path').DS.$userfile['name'];
            $tmp_src	= $userfile['tmp_name'];

            // Move uploaded file
            jimport('joomla.filesystem.file');
            $uploaded = JFile::upload($tmp_src, $tmp_dest, false, true);


            $archivename = $tmp_dest;

            // Temporary folder to extract the archive into
            $tmpdir = uniqid('install_');

            // Clean the paths to use for archive extraction
            $extractdir = JPath::clean(dirname($tmp_dest).DS.$tmpdir);
            $archivename = JPath::clean($archivename);

            // do the unpacking of the archive
            $result = JArchive::extract( $archivename, $extractdir );

        } else if(JFolder::exists(JRequest::getVar('install_path', '') )
                && ( JFile::exists(JRequest::getVar('install_path', '') . DS . 'install.php') || JFile::exists(JRequest::getVar('install_path', '') . DS . 'update.php') ) ) {
            $extractdir = JRequest::getVar('install_path', '');
            $result = true;
        }

        if ( $result === false ) {
            $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=plugins&limitstart='.JRequest::getInt('limitstart'), JText::_('Plugin Installation Failed') );
        }else{
            if(JFile::exists( $extractdir . DS . 'install.php' ) || JFile::exists( $extractdir . DS . 'update.php' ) ){
                
                $installer = null;
                $destination = '';
                
                if(JFile::exists( $extractdir . DS . 'install.php' )){
                    
                    $libpath = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce' . DS . 'classes' . DS . 'plugin' . DS;
                    require_once($libpath . 'CrBcInstaller.php');
                    require_once($extractdir . DS . 'install.php');
                    $installer = new CrBcInstallation();
                    if($installer instanceof CrBcInstaller){
                        $destination = JPATH_SITE . DS . 'media' . DS . 'breezingcommerce' . DS . 'plugins' . DS . $installer->type . DS . $installer->name;
                    }
                }
                
                if(JFolder::exists($destination) && JFile::exists( $extractdir . DS . 'update.php' ) ){
                    
                    $libpath = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce' . DS . 'classes' . DS . 'plugin' . DS;
                    require_once($libpath . 'CrBcUpdater.php');
                    require_once($extractdir . DS . 'update.php');
                    $installer = new CrBcUpdate();
                    if($installer instanceof CrBcUpdater){
                        $destination = JPATH_SITE . DS . 'media' . DS . 'breezingcommerce' . DS . 'plugins' . DS . $installer->type . DS . $installer->name;
                        if(JFolder::exists($destination)){
                            JFolder::delete($destination);
                            $move_result = JFolder::move($extractdir, $destination);
                            if(true === $move_result){
                                $installer->update();
                                JFile::delete($destination . DS . 'update.php');
                                if(JFile::exists($destination . DS . 'install.php')){
                                    JFile::delete($destination . DS . 'install.php');
                                }
                                $db = JFactory::getDBO();
                                $db->setQuery("Select id From #__breezingcommerce_plugins Where `type` = " . $db->Quote($installer->type) . " And `name` = " . $db->Quote($installer->name));
                                $id = $db->loadResult();
                                if($id) {
                                    $db->setQuery("Update #__breezingcommerce_plugins Set `version` = ".$db->Quote($installer->version)." Where id = " . $id);
                                    $db->query();
                                }

                                $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=plugins&limitstart='.JRequest::getInt('limitstart'), JText::_('Plugin install update success') );

                            }else{
                                $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=plugins&limitstart='.JRequest::getInt('limitstart'), $move_result );
                            }
                        }else{
                            $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=plugins&limitstart='.JRequest::getInt('limitstart'), JText::_('Plugin installation nothing to update') );
                        }
                    }else{
                        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=plugins&limitstart='.JRequest::getInt('limitstart'), JText::_('Plugin installation class is not valid') );
                    }
                }
                else
                {
                    if($installer instanceof CrBcInstaller){
                        $base_path = JPATH_SITE . DS . 'media' . DS . 'breezingcommerce';
                        if(!JFolder::exists($base_path)) JFolder::create($base_path);
                        if(!JFolder::exists($base_path . DS . 'plugins')) JFolder::create($base_path . DS . 'plugins');
                        if(!JFolder::exists($base_path . DS . 'plugins' . DS . $installer->type)) JFolder::create($base_path . DS . 'plugins' . DS . $installer->type);
                        if(JFolder::exists($destination)){
                            JFolder::delete($destination);
                        }
                        $move_result = JFolder::move($extractdir, $destination);
                        if(true === $move_result){
                            $installer->install();
                            JFile::delete($destination . DS . 'install.php');
                            if(JFile::exists($destination . DS . 'update.php')){
                                JFile::delete($destination . DS . 'update.php');
                            }
                            $db = JFactory::getDBO();
                            $db->setQuery("Select count(id) From #__breezingcommerce_plugins Where `type` = " . $db->Quote($installer->type) . " And `name` = " . $db->Quote($installer->name));
                            $registered = $db->loadResult();
                            if(!$registered) {
                                $db->setQuery("Insert Into #__breezingcommerce_plugins (`type`,`name`, `version`, `ordering`) Values (".$db->Quote($installer->type).", ".$db->Quote($installer->name).", ".$db->Quote($installer->version).", 99999)");
                                $db->query();
                            }
                            $model = $this->getModel( 'plugins' );
                            $model->reorderPlugins($installer->type);
                            $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=plugins&limitstart='.JRequest::getInt('limitstart'), JText::_('Plugin installed successfully') );
                        }else{
                            $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=plugins&limitstart='.JRequest::getInt('limitstart'), $move_result );
                        }
                    }else{
                        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=plugins&limitstart='.JRequest::getInt('limitstart'), JText::_('Plugin installation class is not valid') );
                    }
                }
            }else{
                $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=plugins&limitstart='.JRequest::getInt('limitstart'), JText::_('Plugin installation install update file not found') );
            }
        }
    }

    function orderup() {
        $model = $this->getModel( 'plugin' );
        $model->move(-1);
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=plugins&limitstart='.JRequest::getInt('limitstart') );
    }

    function orderdown() {
        $model = $this->getModel( 'plugin' );
        $model->move(1);
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=plugins&limitstart='.JRequest::getInt('limitstart') );
    }

    function saveorder(){
        $model = $this->getModel( 'plugins' );
        $model->saveOrder();
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=plugins&limitstart='.JRequest::getInt('limitstart') );
    }

    function publish() {
        $cid = JRequest::getVar('cid', array(), '', 'array');
        
        if(count($cid) == 1)
        {
            $model = $this->getModel( 'plugin' );
            $model->setPublished();
        }
        else if(count($cid) > 1)
        {
            $model = $this->getModel( 'plugins' );
            $model->setPublished();
        }
        
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=plugins&limitstart='.JRequest::getInt('limitstart'), JText::_('Plugin Published') );
    }

    function unpublish() {
        $cid = JRequest::getVar('cid', array(), '', 'array');
        
        if(count($cid) == 1)
        {
            $model = $this->getModel( 'plugin' );
            $model->setUnpublished();
        }
        else if(count($cid) > 1)
        {
            $model = $this->getModel( 'plugins' );
            $model->setUnpublished();
        }

        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=plugins&limitstart='.JRequest::getInt('limitstart'), JText::_('Plugin Unpublished') );
    }

    /**
     * display the edit form
     * @return void
     */
    function edit()
    {
        JRequest::setVar( 'view', 'plugin' );
        JRequest::setVar( 'layout', 'form'  );
        JRequest::setVar( 'hidemainmenu', 1 );

        parent::display();
    }

    function save()
    {
        $model = $this->getModel('plugin');

        if ($model->store()) {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_PLUGIN_SAVED' );
        } else {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_ERROR_SAVING_PLUGIN' );
        }

        // Check the table in so it can be edited.... we are done with it anyway
        $link = 'index.php?option=com_breezingcommerce&controller=plugins&limitstart='.JRequest::getInt('limitstart');
        $this->setRedirect($link, $msg);
    }

    function remove()
    {
        $model = $this->getModel('plugin');
        if(!$model->delete()) {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_AT_LEAST_ONE_PLUGIN_COULD_NOT_BE_DELETED' );
        } else {
            $msg = JText::_( 'COM_BREEZINGCOMMERCE_PLUGIN_DELETED' );
        }

        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=plugins&limitstart='.JRequest::getInt('limitstart'), $msg );
    }

    function cancel()
    {
        $msg = JText::_( 'Operation Cancelled' );
        $this->setRedirect( 'index.php?option=com_breezingcommerce&controller=plugins&limitstart='.JRequest::getInt('limitstart'), $msg );
    }

    function display($cachable = false, $urlparams = array())
    {
        JRequest::setVar('view', 'plugins');
        
        parent::display();
    }
}
