<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/
defined( '_JEXEC' ) or die( 'Restricted access' );

$libpath = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce' . DS . 'classes' . DS . 'plugin' . DS;
require_once($libpath . 'CrBcAPaymentAdminPlugin.php');
require_once($libpath . 'CrBcPaymentAdminPlugin.php');

class CrBc_Plugins_Payment_Banktransfer_Admin extends CrBcAPaymentAdminPlugin implements CrBcPaymentAdminPlugin
{
    public function  __construct() {
        
        require_once(JPATH_SITE.'/administrator/components/com_breezingcommerce/classes/CrBcPane.php');
        
        // always call the parent constructor and always call it _first_
        parent::__construct();
        // define the default table for built-in list/details view
        $this->table = '#__breezingcommerce_plugin_banktransfer';
    }
    
    public function afterStore($data){
        
        if(isset($data['info_translation']) && $data['info_translation'] != ''){
            $fields = array();
            $fields['body'] = trim($data['info_translation']);
            CrBcHelpers::storeTranslation($fields, $data[$this->identity_column], 'plugin_payment_banktransfer');
        }
    }

    /**
     * Called on render HTML
     */
    function display(){
        $this->setDetailsView(array('apply', 'cancel'));
    }

    /**
     * Overriden from CrBcAdminPlugin
     * @param array $toolbarItems
     */
    function setDetailsView($toolbarItems = array()){

        $this->setToolbar($toolbarItems);
        $this->template = 'details';

        $db = JFactory::getDBO();
 
        $db->setQuery("Select * From " . $this->table . " Order By `".$this->identity_column."` Desc Limit 1");
        $row = $db->loadObject();

        if(!($row instanceof stdClass)){
            $row = new stdClass();
            $id = $this->identity_column;
            $row->$id = 0;
            $row->info = '';
        }
        
        $id = $this->identity_column;
        $db->setQuery("Select * From #__breezingcommerce_translations Where item_id = ".$row->$id." And type = 'plugin_payment_banktransfer' And language_code = ".$db->quote( JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','') ));
        $info_translation = $db->loadObject();
        $row->info_translation = '';
        if($info_translation !== null){
            $row->info_translation = $info_translation->body;
        }

        $this->assignRef('entity', $row);
    }

    function init($subject = null){
        // nothing yet
    }

    function getPaymentInfo(){
        $db = JFactory::getDBO();

        $db->setQuery("Select * From " . $this->table . " Order By `".$this->identity_column."` Desc Limit 1");
        $row = $db->loadObject();

        if(!($row instanceof stdClass)){
            $row = new stdClass();
            $row->info = JText::_('COM_BREEZINGCOMMERCE_NO_PAYMENT_INFO');
        }

        return $row->info;
    }

    function getAfterPaymentInfo(){
        return JText::_('COM_BREEZINGCOMMERCE_BANK_CLEARED');
    }

    public function getPluginDisplayName(){
        return JText::_('COM_BREEZINGCOMMERCE_BANK_TRANSFER');
    }
    
    public function getPluginDescription(){
        return JText::_('COM_BREEZINGCOMMERCE_BANK_DESCRIPTION');
    }
}
