<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// No direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

class BreezingcommerceModelAttribute extends JModelLegacy
{

    function  __construct($config)
    {
        parent::__construct();

        $mainframe = JFactory::getApplication();
        $option = 'com_breezingcommerce';

        $array = JRequest::getVar('cid',  0, '', 'array');
        $this->setId((int)$array[0]);
        if(JRequest::getInt('id',0)>0){
            $this->setId(JRequest::getInt('id',0));
        }

        $limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
        $limitstart = JRequest::getVar('limitstart', 0, '', 'int');

        // In case limit has been changed, adjust it
        $limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

        $this->setState('limit', $limit);
        $this->setState('limitstart', $limitstart);

        $filter_order     = $mainframe->getUserStateFromRequest(  $option.'attributeitems_filter_order', 'filter_order', 'ordering', 'cmd' );
        $filter_order_Dir = $mainframe->getUserStateFromRequest( $option.'attributeitems_filter_order_Dir', 'filter_order_Dir', 'asc', 'word' );

        $this->setState('attributeitems_filter_order', $filter_order);
        $this->setState('attributeitems_filter_order_Dir', $filter_order_Dir);

        $filter_state = $mainframe->getUserStateFromRequest( $option.'attributeitems_filter_state', 'filter_state', '', 'word' );
        $this->setState('attributeitems_filter_state', $filter_state);

    }

    function setPublished()
    {
        if (empty( $this->_data )) {
            $this->_db->setQuery( ' Update #__breezingcommerce_attributes '.
                        '  Set published = 1 Where id = '.$this->_id );
            $this->_db->query();
        }
    }

    function setUnpublished()
    {
       if (empty( $this->_data )) {
           $this->_db->setQuery( ' Update #__breezingcommerce_attributes '.
                        '  Set published = 0 Where id = '.$this->_id );
           $this->_db->query();
       }
    }

    function setListPublished()
    {
        $items	= JRequest::getVar( 'cid', array(), 'post', 'array' );
        JArrayHelper::toInteger($items);
        if (count($items)) {
            $this->_db->setQuery( ' Update #__breezingcommerce_attribute_items '.
                        '  Set published = 1 Where id In ( '.implode(',', $items) . ')' );
            $this->_db->query();
        }
    }

    function setListUnpublished()
    {
       $items	= JRequest::getVar( 'cid', array(), 'post', 'array' );
        JArrayHelper::toInteger($items);
        if (count($items)) {
            $this->_db->setQuery( ' Update #__breezingcommerce_attribute_items '.
                        '  Set published = 0 Where id In ( '.implode(',', $items) . ')' );
            $this->_db->query();
        }
    }

    /*
     * MAIN DETAILS AREA
     */

    /**
     *
     * @param int $id 
     */
    function setId($id) {
        // Set id and wipe data
        $this->_id      = $id;
        $this->_data    = null;
    }

    /**
    * Gets the currencies
    * @return array List of currencies
    */
    function getAttribute()
    {
        
        $query = ' Select * From #__breezingcommerce_attributes '.
                    '  Where id = '.$this->_id;
        $this->_db->setQuery( $query );
        $data = $this->_db->loadObject();
        
        if (!$data) {
            $data = new stdClass();
            $data->id = 0;
            $data->name = null;
            $data->ordering = null;
            $data->published = null;
            $data->display_as = null;
            $data->min_amount = null;
            $data->allow_amount = null;
            $data->required = null;
            $data->tag = null;
        }
        
        $data->name_translation = '';
        
        $query = ' Select * From #__breezingcommerce_translations '.
                    '  Where language_code = '.$this->_db->quote( JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','') ) . ' And type = "attribute" And item_id = '.$this->_id;
        $this->_db->setQuery( $query );
        $translation = $this->_db->loadObject();
        
        $data->name_translation = '';
        
        if($translation !== null){
            $data->name_translation = $translation->title;
        }
        
        return $data;

    }

    private function buildOrderBy() {
        $mainframe = JFactory::getApplication();
        $option = 'com_breezingcommerce';

        $orderby = '';
        $filter_order     = $this->getState('attributeitems_filter_order');
        $filter_order_Dir = $this->getState('attributeitems_filter_order_Dir');

        /* Error handling is never a bad thing*/
        if(!empty($filter_order) && !empty($filter_order_Dir) ) {
            $orderby = ' ORDER BY '.$filter_order.' '.$filter_order_Dir . ' , ordering ';
        } else {
           $orderby = ' ORDER BY ordering ';
        }

        return $orderby;
    }


    function _buildQuery()
    {
        $filter_state = '';
        if($this->getState('attributeitems_filter_state') == 'P' || $this->getState('attributeitems_filter_state') == 'U')
        {
            $published = 0;
            if($this->getState('attributeitems_filter_state') == 'P')
            {
                $published = 1;
            }

            $filter_state .= ' And published = ' . $published;
        }

        return "Select * From #__breezingcommerce_attribute_items Where attribute_id = " . $this->_id . $filter_state . $this->buildOrderBy();
    }

    function getData()
    {
        $this->_db->setQuery($this->_buildQuery(), $this->getState('limitstart'), $this->getState('limit'));
        $entries = $this->_db->loadObjectList();
        $props = array();

        $i = 0;
        foreach( $entries As $entry ){

            if(!isset($props[$i]))
            {
                $props[$i] = new stdClass();
            }

            $this->_db->setQuery("Select title From #__breezingcommerce_products Where id = " . $entry->product_id);
            $product_title = $this->_db->loadResult();

            $props[$i]->id = $entry->id;
            $props[$i]->name = $entry->name;
            $props[$i]->plus_price = $entry->plus_price;
            $props[$i]->product_id = $entry->product_id;
            $props[$i]->product_title = $product_title ? $product_title : '';
            $props[$i]->ordering = $entry->ordering;
            $props[$i]->published = $entry->published;
            
            $this->_db->setQuery("Select * From #__breezingcommerce_translations Where item_id = ".$entry->id." And type = 'attribute_item_".$this->_id."' And language_code = ".$this->_db->quote( JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','') ));
            $name_translation = $this->_db->loadObject();
            $props[$i]->name_translation = '';
            if($name_translation !== null){
                $props[$i]->name_translation = $name_translation->title;
            }
            
            $i++;
        }

        return $props;
    }

    function store()
    {
        $row = $this->getTable();

        $data = JRequest::get( 'post' );
        
        if(trim($data['tag']) == ''){
            $data['tag'] = 'default';
        }
        
        $data['tag'] = strtolower(trim($data['tag']));
        $data['min_amount'] = intval($data['min_amount']) < 0 ? 0 : intval($data['min_amount']);

        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        $attribute_id = 0;
        $storeRes = $row->store();

        if (!$storeRes) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        else
        {
            if( intval($data['id']) != 0 )
            {
                $attribute_id = intval($data['id']);
            }
            else
            {
                $attribute_id = $this->_db->insertid();
            }
        }
        
        $row->reorder();

        if(isset($data['name_translation']) && $data['name_translation'] != ''){
            $fields = array();
            $fields['title'] = trim($data['name_translation']);
            CrBcHelpers::storeTranslation($fields, $attribute_id, 'attribute');
        }

        $names = JRequest::getVar('attributeNames', array());
        $names_translation = JRequest::getVar('attributeNames_translation', array());
        
        $plus_prices = JRequest::getVar('plusPrices', array());
        $product_ids = JRequest::getVar('productIds', array());
        $items = JRequest::getVar( 'cid', array(), 'post', 'array' );
        
        JArrayHelper::toInteger($items);
        $size = count($items);
        for($i = 0; $i < $size; $i++)
        {
            $this->_db->setQuery("Update #__breezingcommerce_attribute_items Set `product_id` = ".$this->_db->Quote(intval($product_ids[$items[$i]])).", `plus_price` = ".$this->_db->Quote(trim($plus_prices[$items[$i]])).",`name` =  ".$this->_db->Quote(trim($names[$items[$i]]))." Where id = " . $items[$i]);
            $this->_db->query();
            
            if(isset($names_translation[$items[$i]]) && trim($names_translation[$items[$i]]) != ''){
                $fields = array();
                $fields['title'] = trim($names_translation[$items[$i]]);
                CrBcHelpers::storeTranslation($fields, $items[$i], 'attribute_item_'.$attribute_id);
            }
        }

        // NEW ATTRIBUTE
        $name = JRequest::getVar('attributeName', '');
        $name_translation = JRequest::getVar('attributeName_translation', '');
        
        $plus_price = JRequest::getFloat('plus_price', 0);
        $product_id = JRequest::getInt('product_id', 0);
        
        if($name != ''){

            $this->_db->setQuery("Insert Into #__breezingcommerce_attribute_items (`attribute_id`,`name`,`plus_price`,`product_id`) Values ($attribute_id,".$this->_db->Quote(trim($name)).",".$this->_db->Quote(trim($plus_price)).",".$this->_db->Quote(intval($product_id)).")");
            $this->_db->query();
            $key_id = $this->_db->insertid();
            $this->getTable('attributeitems')->reorder('attribute_id = ' . $attribute_id);
            
            if($name_translation != ''){
                $fields = array();
                $fields['title'] = trim($name_translation);
                CrBcHelpers::storeTranslation($fields, $key_id, 'attribute_item_'.$attribute_id);
            }

        }

        return true;
    }

    function delete()
    {
        $cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
        JArrayHelper::toInteger($cids);
        $row = $this->getTable();

        foreach($cids as $cid) {

            $this->_db->setQuery("
                Delete
                    `items`.*
                From
                    #__breezingcommerce_attribute_items As `items`
                Where
                    `items`.attribute_id = " . $cid);
            
            $this->_db->query();

            $this->getTable('attributeitems')->reorder('attribute_id = ' . $cid);

            $this->_db->setQuery("Delete From #__breezingcommerce_product_attributes Where attribute_id = " . $cid);
            $this->_db->query();
            $this->_db->setQuery("Delete From #__breezingcommerce_product_attribute_items Where attribute_id = " . $cid);
            $this->_db->query();
            
            $this->_db->setQuery("Delete From #__breezingcommerce_translations Where type = 'attribute' And item_id = " . $cid);
            $this->_db->query();
            
            $this->_db->setQuery("Delete From #__breezingcommerce_translations Where type = 'attribute_item_".$cid."'");
            $this->_db->query();

            if (!$row->delete( $cid )) {
                $this->setError( $row->getErrorMsg() );
                return false;
            }
        }

        $row->reorder();

        return true;
    }

    function listDelete()
    {
        $cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
        JArrayHelper::toInteger($cids);
        foreach($cids as $cid) {
            $this->_db->setQuery("
                Delete
                    `items`.*
                From
                    #__breezingcommerce_attribute_items As `items`
                Where
                    `items`.id = " . $cid);

            $this->_db->query();
            $this->getTable('attributeitems')->reorder('attribute_id = ' . $this->_id);

            $this->_db->setQuery("Delete From #__breezingcommerce_product_attribute_items Where attribute_item_id = " . $cid);
            $this->_db->query();
            
            $this->_db->setQuery("Delete From #__breezingcommerce_translations Where type = 'attribute_item_".$this->_id."' And item_id = " . $cid);
            $this->_db->query();
        }
    }

    function move($direction) {

      $db = JFactory::getDBO();
      $mainframe = JFactory::getApplication();

      $row = $this->getTable('attribute');

      if (!$row->load($this->_id)) {
         $this->setError($db->getErrorMsg());
         return false;
      }

      if (!$row->move( $direction )) {
         $this->setError($db->getErrorMsg());
         return false;
      }

      return true;
   }

   function listMove($direction) {
      $mainframe = JFactory::getApplication();
      $items = JRequest::getVar( 'cid', array(), 'post', 'array' );
      JArrayHelper::toInteger($items);

      if(count($items)){
          $db = JFactory::getDBO();
          $row = $this->getTable('attributeitems');

          if (!$row->load($items[0])) {
             $this->setError($db->getErrorMsg());
             return false;
          }

          if (!$row->move( $direction, 'attribute_id='.$this->_id )) {
             $this->setError($db->getErrorMsg());
             return false;
          }
      }

      return true;
   }

   function getTotal() {
        // Load the content if it doesn't already exist
        if (empty($this->_total)) {
            $query = $this->_buildQuery();
            $this->_total = $this->_getListCount($query);
        }
        return $this->_total;
    }

    function getPagination() {
        // Load the content if it doesn't already exist
        if (empty($this->_pagination)) {
            jimport('joomla.html.pagination');
            $this->_pagination = new JPagination($this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
        }
        return $this->_pagination;
    }

    function listSaveOrder()
    {
        $items	= JRequest::getVar( 'cid', array(), 'post', 'array' );
        JArrayHelper::toInteger($items);

        $total		= count( $items );
        $row		= $this->getTable('attributeitems');
        $groupings	= array();

        $order		= JRequest::getVar( 'order', array(), 'post', 'array' );
        JArrayHelper::toInteger($order);

        // update ordering values
        for( $i=0; $i < $total; $i++ ) {
            $row->load( $items[$i] );
            if ($row->ordering != $order[$i]) {
                $row->ordering = $order[$i];
                if (!$row->store()) {
                    $this->setError($row->getError());
                    return false;
                }
            } // if
        } // for


        $row->reorder("attribute_id = " . $this->_id);
    }
}
