<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// No direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

class BreezingcommerceModelCategories extends JModelLegacy
{
    /**
     * Items total
     * @var integer
     */
    private $_total = null;

    /**
     * Pagination object
     * @var object
     */
    private $_pagination = null;

    function  __construct($config) {
        parent::__construct($config);

        
        
        $mainframe = JFactory::getApplication();
        $option = 'com_breezingcommerce';
        
        $search = $mainframe->getUserStateFromRequest("$option.category_search", 'category_search', '', 'string');
        $this->setState('category_search', $search);

        $search = $mainframe->getUserStateFromRequest("$option.category_search_by", 'category_search_by', '', 'string');
        $this->setState('category_search_by', $search);

        // Get pagination request variables
        $limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
        $limitstart = JRequest::getVar('limitstart', 0, '', 'int');

        // In case limit has been changed, adjust it
        $limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

        $this->setState('limit', $limit);
        $this->setState('limitstart', $limitstart);

        $filter_order     = $mainframe->getUserStateFromRequest(  $option.'category_filter_order', 'filter_order', 'c.ordering', 'cmd' );
        $filter_order_Dir = $mainframe->getUserStateFromRequest( $option.'category_filter_order_Dir', 'filter_order_Dir', 'asc', 'word' );

        $this->setState('category_filter_order', $filter_order);
        $this->setState('category_filter_order_Dir', $filter_order_Dir);

        $filter_state = $mainframe->getUserStateFromRequest( $option.'category_filter_state', 'filter_state', '', 'word' );
        $this->setState('category_filter_state', $filter_state);
    }

    /**
     * TODO: check cid array for being integers only
     * 
     * CURRENTLY NOT CALLED, INSTEAD THE SINGLE COPY IS USED IN CATEGORY MODEL!
     */
    function copy()
    {
        $cids = JRequest::getVar('cid', array(), '', 'array');
        JArrayHelper::toInteger($cids);
        $this->_db->setQuery( ' Select * From #__breezingcommerce_categories '.
                '  Where id In ( ' . implode(',',$cids)  . ')');
        $result = $this->_db->loadObjectList();
        require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcImage.php');
        foreach($result As $obj)
        {
            $origId = $obj->id;
            unset($obj->id);
            $obj->title = 'Copy of ' . $obj->title;
            $obj->created = date('Y-m-d H:i:s');
            $obj->created_by = JFactory::getUser()->get('id', 0);
            $obj->created_by_alias = JFactory::getUser()->get('username', '');
            $obj->modified = date('Y-m-d H:i:s');
            $obj->modified_by = JFactory::getUser()->get('id', 0);
            $obj->modified_by_alias = JFactory::getUser()->get('username', '');
            $this->_db->insertObject('#__breezingcommerce_categories', $obj);

            $insertId = $this->_db->insertid();
            CrBcImage::copyCategoryImages($origId, $insertId);
            CrBcHelpers::copyTranslations($origId, $insertId, 'category_image');
            CrBcHelpers::copyTranslations($origId, $insertId, 'category');
            
            // Rebuild the path for the category:
            $row = $this->getTable('category');
            $row->load($insertId);
            if (!$row->rebuildPath($insertId))
            {
                    $this->setError($row->getError());
                    return false;
            }

            $build = $this->getTable('category');
            $build->load($row->getRootId());

            if (!$build->rebuild($build->id, $build->lft, $build->level, $build->path))
            {
                $this->setError($build->getError());
                return false;
            }
            
            CrBcCategoriesHelper::reorderCategories($this, $insertId);
        }

        
    }

    function setPublished()
    {
        $cids = JRequest::getVar('cid', array(), '', 'array');
        JArrayHelper::toInteger($cids);
        $this->_db->setQuery( ' Update #__breezingcommerce_categories '.
                '  Set published = 1 Where id In ( ' . implode(',',$cids)  . ')');
        $this->_db->query();

    }

    function setUnpublished()
    {
        $cids = JRequest::getVar('cid', array(), '', 'array');
        JArrayHelper::toInteger($cids);
        $this->_db->setQuery( ' Update #__breezingcommerce_categories '.
                '  Set published = 0 Where id In ( ' . implode(',',$cids)  . ')');
        $this->_db->query();
    }

    /*
     *
     * MAIN LIST AREA
     * 
     */

    private function buildOrderBy() {
        $mainframe = JFactory::getApplication();
        $option = 'com_breezingcommerce';

        $orderby = '';
        $filter_order     = $this->getState('category_filter_order');
        $filter_order_Dir = $this->getState('category_filter_order_Dir');

        /* Error handling is never a bad thing*/
        if(!empty($filter_order) && $filter_order != 'c.ordering' && !empty($filter_order_Dir) ) {
            $orderby = ' ORDER BY '.$filter_order.' '.$filter_order_Dir . ' , c.lft Asc ';
        } else {
           $orderby = ' ORDER BY c.lft Asc ';
        }

        return $orderby;
    }


    /**
     * @return string The query
     */
    private function _buildQuery(){

        $where = '';
        $match = '';
        
        if($this->getState('category_search_by') == 'fulltext' && $this->getState('category_search') != '')
        {
            //$match = " And Match (c.title, c.description_fulltext) Against (" . $this->_db->Quote( $this->getState('category_search') ) . " IN BOOLEAN MODE) ";
            
            $match = CrBcHelpers::createMatchAgainstLookupSql($this->getState('category_search'), array('title', 'description_fulltext'), 'c', 'And');
        }
        else if( ( $this->getState('category_search_by') == 'created' || $this->getState('category_search_by') == 'modified' ) && $this->getState('category_search') != '')
        {
            $column = 'c.'.$this->_db->quoteName($this->getState('category_search_by'));
            $ex = explode('|', $this->getState('category_search'));

            if(count($ex) == 1)
            {
                $ex = explode(' ', $this->getState('category_search'));

                if( count($ex) == 1 )
                {
                    $match = " And $column Between " . $this->_db->Quote( trim($ex[0]) . ' 00:00:00' ) . " And " . $this->_db->Quote( trim($ex[0]) . ' 23:59:59' );
                }
                else if( count($ex) == 2 )
                {
                    $match = " And $column = " . $this->_db->Quote( trim($ex[0]) . ' ' . trim($ex[1]) ) . " ";
                }
            }
            else if(count($ex) == 2)
            {
                $dateFrom = trim($ex[0]);
                $dateTo = trim($ex[1]);
                
                $exFrom = explode(' ', $dateFrom);
                $exTo = explode(' ', $dateTo);

                if( count($exFrom) == 1 && count($exTo) == 1 )
                {
                    $match = " And $column Between " . $this->_db->Quote( trim($exFrom[0]) . ' 00:00:00' ) . " And " . $this->_db->Quote( trim($exTo[0]) . ' 23:59:59' );
                }
                else if( count($exFrom) == 2 && count($exTo) == 2 )
                {
                    $match = " And $column Between " . $this->_db->Quote( trim($exFrom[0]) . ' ' . trim($exFrom[1]) ) . " And " . $this->_db->Quote( trim($exTo[0]) . ' ' . trim($exTo[1]) ) . " ";
                }
            }
        }
        else if( $this->getState('category_search_by') == 'created_by_alias' && $this->getState('category_search') != '')
        {
            $column = 'c.'.$this->_db->quoteName($this->getState('category_search_by'));
            $match = " And $column = " . $this->_db->Quote( $this->getState('category_search' ) ) . " ";
        }

        $filter_state = '';
        if($this->getState('category_filter_state') == 'P' || $this->getState('category_filter_state') == 'U')
        {
            $published = 0;
            if($this->getState('category_filter_state') == 'P')
            {
                $published = 1;
            }

            $filter_state .= ' And c.published = ' . $published;
        }

        //if($match != '' || $filter_state != '')
        //{
            $where = ' Where c.id <> 1 And c.alias <> "root" And c.title <> "ROOT" ';
        //}

        //echo 'Select SQL_CALC_FOUND_ROWS c.* From #__breezingcommerce_categories As c ' . $where . $match . $filter_state . $this->buildOrderBy();
        return 'Select SQL_CALC_FOUND_ROWS c.* From #__breezingcommerce_categories As c ' . $where . $match . $filter_state . $this->buildOrderBy();
    }

    /**
    * Gets the categories
    * @return array List of categories
    */
    function getData()
    {
        // Lets load the data if it doesn't already exist
        if (empty( $this->_data ))
        {
            $this->_data = $this->_getList( $this->_buildQuery(), $this->getState('limitstart'), $this->getState('limit') );
            
        }

        return $this->_data;
    }

    function getTotal() {
        // Load the content if it doesn't already exist
        if (empty($this->_total)) {
            $query = $this->_buildQuery();
            $this->_total = $this->_getListCount($query);
        }
        return $this->_total;
    }

    function getPagination() {
        // Load the content if it doesn't already exist
        if (empty($this->_pagination)) {
            jimport('joomla.html.pagination');
            $this->_pagination = new JPagination($this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
        }
        return $this->_pagination;
    }

    function saveOrder()
    {
        $items	= JRequest::getVar( 'cid', array(), 'post', 'array' );
        JArrayHelper::toInteger($items);
        
        $total		= count( $items );
        $row		= $this->getTable('category');
        $groupings	= array();

        $order		= JRequest::getVar( 'order', array(), 'post', 'array' );
        JArrayHelper::toInteger($order);

        // update ordering values
        for( $i=0; $i < $total; $i++ ) {
            $row->load( $items[$i] );
            // track parents
            $groupings[] = $row->parent_id;
            if ($row->ordering != $order[$i]) {
                $row->ordering = $order[$i];
                if (!$row->store()) {
                    $this->setError($row->getError());
                    return false;
                }
            } // if
        } // for

        // execute updateOrder for each parent group
        $groupings = array_unique( $groupings );
        foreach ($groupings as $group) {
            $row->reorder('parent_id = '.(int) $group);
        }
    }

}
