<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// No direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

class BreezingcommerceModelCategoryproducts extends JModelLegacy
{
    /**
     * Items total
     * @var integer
     */
    private $_total = null;

    /**
     * Pagination object
     * @var object
     */
    private $_pagination = null;

    function  __construct($config) {
        parent::__construct($config);

        $mainframe = JFactory::getApplication();
        $option = 'com_breezingcommerce';

        // Get pagination request variables
        $limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
        $limitstart = JRequest::getVar('limitstart', 0, '', 'int');
        $product_id = JRequest::getVar('category_id', 0, '', 'int');

        // In case limit has been changed, adjust it
        $limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

        $this->setState('limit', $limit);
        $this->setState('limitstart', $limitstart);

        $filter_order     = $mainframe->getUserStateFromRequest(  $option.'categoryproducts_filter_order', 'filter_order', 'p.ordering', 'cmd' );
        $filter_order_Dir = $mainframe->getUserStateFromRequest( $option.'categoryproducts_filter_order_Dir', 'filter_order_Dir', 'asc', 'word' );

        $this->setState('categoryproducts_filter_order', $filter_order);
        $this->setState('categoryproducts_filter_order_Dir', $filter_order_Dir);

        $category_id     = $mainframe->getUserStateFromRequest(  $option.'category_id', 'category_id', 0, 'int' );
        $this->setState('category_id', $category_id);
    }

    /*
     *
     * MAIN LIST AREA
     * 
     */

    /**
     * @return string The query
     */
    private function _buildQuery(){
        //echo 'Select SQL_CALC_FOUND_ROWS p.* From #__breezingcommerce_product_categories As pc, #__breezingcommerce_products As p Where p.id = pc.product_id And pc.category_id = ' . $this->_db->Quote( $this->getState('category_id') ) . ' Order By `pc`.`ordering`';
        return 'Select SQL_CALC_FOUND_ROWS p.*, pc.ordering As ordering, pc.id As product_categories_id From #__breezingcommerce_product_categories As pc, #__breezingcommerce_products As p Where p.id = pc.product_id And pc.category_id = ' . $this->_db->Quote( $this->getState('category_id') ) . ' Order By `pc`.`ordering`';
    }

    function move($direction) {

      $db = JFactory::getDBO();
      $mainframe = JFactory::getApplication();

      $row = $this->getTable('categoryproducts');
      $cids = JRequest::getVar('cid', array(), '', 'array');
      JArrayHelper::toInteger($cids);
      
      if (!$row->load(@$cids[0])) {
         $this->setError($db->getErrorMsg());
         return false;
      }

      if (!$row->move( $direction, 'category_id='.$this->getState('category_id') )) {
         $this->setError($db->getErrorMsg());
         return false;
      }

      //CrBcCategoriesHelper::reorderCategories($this);

      return true;
   }

    /**
    * Gets the currencies
    * @return array List of currencies
    */
    function getData()
    {
        // Lets load the data if it doesn't already exist
        if (empty( $this->_data ))
        {
            $query = $this->_buildQuery();
            $this->_data = $this->_getList( $query, $this->getState('limitstart'), $this->getState('limit') );
        }

        return $this->_data;
    }

    function getTotal() {
        // Load the content if it doesn't already exist
        if (empty($this->_total)) {
            $query = $this->_buildQuery();
            $this->_total = $this->_getListCount($query);
        }
        return $this->_total;
    }

    function getPagination() {
        // Load the content if it doesn't already exist
        if (empty($this->_pagination)) {
            jimport('joomla.html.pagination');
            $this->_pagination = new JPagination($this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
        }
        return $this->_pagination;
    }

    function saveOrder()
    {
        $items	= JRequest::getVar( 'cid', array(), 'post', 'array' );
        JArrayHelper::toInteger($items);

        $total		= count( $items );
        $row		= $this->getTable('categoryproducts');
        $groupings	= array();

        $order		= JRequest::getVar( 'order', array(), 'post', 'array' );
        JArrayHelper::toInteger($order);

        // update ordering values
        for( $i=0; $i < $total; $i++ ) {
            $row->load( $items[$i] );
            // track parents
            $groupings[] = $row->category_id;
            if ($row->ordering != $order[$i]) {
                $row->ordering = $order[$i];
                if (!$row->store()) {
                    $this->setError($row->getError());
                    return false;
                }
            } // if
        } // for

        // execute updateOrder for each parent group
        $groupings = array_unique( $groupings );
        foreach ($groupings as $group) {
            $row->reorder('category_id = '.(int) $group);
        }
    }

}
