<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// No direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

class BreezingcommerceModelFile extends JModelLegacy
{

    function  __construct($config)
    {
        parent::__construct();

        $array = JRequest::getVar('cid',  0, '', 'array');
        $this->setId((int)$array[0]);

    }

    function setPublished()
    {
        if (empty( $this->_data )) {
            $this->_db->setQuery( ' Update #__breezingcommerce_files '.
                        '  Set published = 1 Where id = '.$this->_id );
            $this->_db->query();
        }
    }

    function setUnpublished()
    {
       if (empty( $this->_data )) {
           $this->_db->setQuery( ' Update #__breezingcommerce_files '.
                        '  Set published = 0 Where id = '.$this->_id );
           $this->_db->query();
       }
    }

    /*
     * MAIN DETAILS AREA
     */

    /**
     *
     * @param int $id 
     */
    function setId($id) {
        // Set id and wipe data
        $this->_id      = $id;
        $this->_data    = null;
    }

    /**
    * Gets the file
    * @return array List of file
    */
    function getData()
    {
        // Load the data
        if (empty( $this->_data )) {
            $query = ' Select * From #__breezingcommerce_files '.
                    '  Where id = '.$this->_id;
            $this->_db->setQuery( $query );
            $this->_data = $this->_db->loadObject();
        }
        if (!$this->_data) {
            $this->_data = new stdClass();
            $this->_data->id = 0;
            $this->_data->product_id = 0;
            $this->_data->name = null;
            $this->_data->description = null;
            $this->_data->published = null;
            $this->_data->ordering = null;
            $this->_data->filename = null;
            $this->_data->filename2 = null;
            $this->_data->filesize = null;
            $this->_data->filetype = null;
            $this->_data->requires_verification = null;
            $this->_data->verification_days = null;
            $this->_data->verification_download_tries = null;
        }
        
        // translations
        $this->_data->file_description_translation = '';
        
        if($this->_id){
            
            $this->_db->setQuery("Select * From #__breezingcommerce_translations Where `type` = 'product_file' And item_id = ".$this->_db->quote( $this->_id )." And language_code = ".$this->_db->quote( JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','') ));
            
            $translated_object = $this->_db->loadObject();
            if($translated_object !== null){
                $this->_data->file_description_translation = $translated_object->body;
            }
        }
        // translations end
        
        return $this->_data;

    }

    function store()
    {
        $cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
        JArrayHelper::toInteger($cids);
        $data = JRequest::get( 'post' );
        $data['file_description'] = JRequest::getVar( 'file_description', '', 'POST', 'STRING', JREQUEST_ALLOWHTML );
        require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcFile.php');
        $fileinfo = JRequest::getVar('product_file', null, 'files', 'array');
        $file_id = CrBcFile::store(JRequest::getInt('product_id',0), $fileinfo, $data, $cids[0]);
        
        $fields = array();
        $fields['body'] = JRequest::getVar( 'file_description_translation', '', 'POST', 'STRING', JREQUEST_ALLOWHTML );
        CrBcHelpers::storeTranslation($fields, $file_id, 'product_file');
        
        return true;
    }

    function delete()
    {
        $cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
        JArrayHelper::toInteger($cids);

         // FILES HANDLING
        require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcFile.php');
        CrBcFile::deleteProductFiles(JRequest::getInt('product_id', 0), $cids);

        return true;
    }

    function move($direction) {

      $db = JFactory::getDBO();
      $mainframe = JFactory::getApplication();

      $row = $this->getTable('file');

      if (!$row->load($this->_id)) {
         $this->setError($db->getErrorMsg());
         return false;
      }

      if (!$row->move( $direction, 'product_id = ' . JRequest::getInt('product_id', 0) )) {
         $this->setError($db->getErrorMsg());
         return false;
      }

      return true;
   }

    function saveOrder()
    {
        $items	= JRequest::getVar( 'cid', array(), 'post', 'array' );
        JArrayHelper::toInteger($items);

        $total		= count( $items );
        $row		= $this->getTable('file');
        $groupings	= array();

        $order		= JRequest::getVar( 'order', array(), 'post', 'array' );
        JArrayHelper::toInteger($order);

        for( $i=0; $i < $total; $i++ ) {
            $row->load( $items[$i] );
            $groupings[] = $row->product_id;
            if ($row->ordering != $order[$i]) {
                $row->ordering = $order[$i];
                if (!$row->store()) {
                    $this->setError($row->getError());
                    return false;
                }
            } // if
        } // for

        // execute updateOrder for each parent group
        $groupings = array_unique( $groupings );
        foreach ($groupings as $group) {
            $row->reorder('product_id = '.(int) $group);
        }
    }
}
