<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

// No direct access

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

class BreezingcommerceModelManufacturer extends JModelLegacy
{

    function  __construct($config)
    {
        parent::__construct();

        $mainframe = JFactory::getApplication();
        $option = 'com_breezingcommerce';
        
        $array = JRequest::getVar('cid',  0, '', 'array');
        $this->setId((int)$array[0]);
        
        $search = $mainframe->getUserStateFromRequest("$option.manufacturer_tabStartOffset".$this->getId(), 'tabStartOffset', '', '0');
        $this->setState('manufacturer_tabStartOffset'.$this->getId(), $search);

    }
    
    function getId(){
        return $this->_id;
    }

    function setPublished()
    {
        if (empty( $this->_data )) {
            $this->_db->setQuery( ' Update #__breezingcommerce_manufacturers '.
                        '  Set published = 1 Where id = '.$this->_id );
            $this->_db->query();
        }
    }

    function setUnpublished()
    {
       if (empty( $this->_data )) {
           $this->_db->setQuery( ' Update #__breezingcommerce_manufacturers '.
                        '  Set published = 0 Where id = '.$this->_id );
           $this->_db->query();
       }
    }

    /*
     * MAIN DETAILS AREA
     */

    /**
     *
     * @param int $id 
     */
    function setId($id) {
        // Set id and wipe data
        $this->_id      = $id;
        $this->_data    = null;
    }

    function getData()
    {
        // Load the data
        if (empty( $this->_data )) {
            $query = ' Select * From #__breezingcommerce_manufacturers '.
                    '  Where id = '.$this->_id;
            $this->_db->setQuery( $query );
            $this->_data = $this->_db->loadObject();
        }
        
        if (!$this->_data) {
            $this->_data = new stdClass();
            $this->_data->id = 0;
            $this->_data->name = null;
            $this->_data->alias = null;
            $this->_data->tag = null;
            $this->_data->ordering = null;
            $this->_data->published = null;
            $this->_data->image_name = null;
            $this->_data->image_alt_name = null;
            $this->_data->image_description = null;
            $this->_data->image_background_color = null;
            $this->_data->image_physical_name = null;
            $this->_data->description = null;
            $this->_data->description_fulltext = null;
        }
        
        // translations
        $this->_data->description_translation = '';
        $this->_data->name_translation = '';
        $this->_data->alias_translation = '';
        $this->_data->tag_translation = '';
        
        if($this->_id){
            
            $this->_db->setQuery("Select * From #__breezingcommerce_translations Where `type` = 'manufacturer' And item_id = ".$this->_db->quote( $this->_id )." And language_code = ".$this->_db->quote( JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','') ));
            
            $translated_object = $this->_db->loadObject();
            if($translated_object !== null){
                $this->_data->description_translation = $translated_object->body;
                $this->_data->name_translation = $translated_object->title;
                $this->_data->alias_translation = $translated_object->alias;
            }
        }
        // translations end
        
        // translations
        $this->_data->image_description_translation = '';
        $this->_data->img_alt_name_translation = '';
        
        if($this->_id){
            
            $this->_db->setQuery("Select * From #__breezingcommerce_translations Where `type` = 'manufacturer_image' And item_id = ".$this->_db->quote( $this->_id )." And language_code = ".$this->_db->quote( JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','') ));
            
            $translated_object = $this->_db->loadObject();
            if($translated_object !== null){
                $this->_data->image_description_translation = $translated_object->body;
                $this->_data->img_alt_name_translation = $translated_object->title;
            }
        }
        // translations end
        
        return $this->_data;
    }

    function store()
    {
        $row = $this->getTable();

        $data = JRequest::get( 'post' );

        $data['description'] = JRequest::getVar( 'description', '', 'POST', 'STRING', JREQUEST_ALLOWHTML );
        $data['description_translation'] = JRequest::getVar( 'description_translation', '', 'POST', 'STRING', JREQUEST_ALLOWHTML );
        
        if(trim($data['tag']) == ''){
            $data['tag'] = 'default';
        }
        
        $data['tag'] = strtolower(trim($data['tag']));

        // alias handling
        if(trim($data['alias']) == ''){
            $data['alias'] = CrBcHelpers::getSlug(trim($data['name']));
        }
        
        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        $id = 0;
        $storeRes = $row->store();

        if (!$storeRes) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        else
        {
            if( intval($data['id']) != 0 )
            {
                $manufacturer_id = intval($data['id']);
            }
            else
            {
                $manufacturer_id = $this->_db->insertid();
            }
        }
        
        $row->reorder();

        // translations
        $fields = array();
        $fields['body'] = $data['description_translation'];
        $fields['title'] = $data['name_translation'];
        
        if(isset($data['alias_translation'])){
            
            if(trim($data['alias_translation']) == ''){
                $fields['alias'] = CrBcHelpers::getSlug(trim($data['name_translation']));
            } else{
                $fields['alias'] = $data['alias_translation'];
            }
        }
        
        CrBcHelpers::storeTranslation($fields, $manufacturer_id, 'manufacturer');
        
        /**
         * TODO: remove any special characters from image name
         */
        $data['img_description'] = JRequest::getVar( 'description', '', 'POST', 'STRING', JREQUEST_ALLOWHTML );
        $data['img_description_translation'] = JRequest::getVar( 'img_description_translation', '', 'POST', 'STRING', JREQUEST_ALLOWHTML );
        
        $fileinfo = JRequest::getVar('manufacturer_image', null, 'files', 'array');
        $data['img_name'] = strtolower( str_replace(array("-"," ","'","\"","\\","/"), array('_','_','','','',''), $data['img_name']) );

        if(trim($data['img_name']) == ''){
            $destNameNoExt = explode('.',$fileinfo['name']);
            unset($destNameNoExt[count($destNameNoExt)-1]);
            $destNameNoExt = implode('.', $destNameNoExt);
            $data['img_name'] = strtolower( str_replace(array("-"," ","'","\"","\\","/"), array('_','_','','','',''), $destNameNoExt) );
        }

        if(intval($fileinfo['size']) > 0 ) {

            require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcImage.php');
            
            $data['image_name'] = $data['img_name'];
            $image = CrBcImage::generateManufacturerImages($fileinfo, $data);

            CrBcImage::deleteManufacturerImages($manufacturer_id);
            
            if(false !== $image)
            {
                $this->_db->setQuery(
                        "Update
                                #__breezingcommerce_manufacturers
                            Set
                                `image_name` = " . $this->_db->Quote($data['img_name']) . ",
                                `image_alt_name` = " . $this->_db->Quote($data['img_alt_name']) . ",
                                `image_description` = ". $this->_db->Quote($data['img_description']) .",
                                `image_background_color` = ". $this->_db->Quote($data['img_background_color']) .",
                                `image_physical_name` = ". $this->_db->Quote($image) ."
                            Where
                                id = " . $this->_db->Quote($manufacturer_id) . "
                            "
                );
                $this->_db->query();
            }
        }else{
                $this->_db->setQuery(
                        "Update
                                #__breezingcommerce_manufacturers
                            Set
                                `image_name` = " . $this->_db->Quote($data['img_name']) . ",
                                `image_alt_name` = " . $this->_db->Quote($data['img_alt_name']) . ",
                                `image_description` = ". $this->_db->Quote($data['img_description']) .",
                                `image_background_color` = ". $this->_db->Quote($data['img_background_color']) ."
                            Where
                                id = " . $this->_db->Quote($manufacturer_id) . "
                            "
                );
                $this->_db->query();
        }
        
        $fields = array();
        $fields['body'] = $data['img_description_translation'];
        $fields['title'] = $data['img_alt_name_translation'];
        CrBcHelpers::storeTranslation($fields, $manufacturer_id, 'manufacturer_image');

        if(JRequest::getBool('delete_uploaded_image', false))
        {
            require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcImage.php');
            CrBcImage::deleteManufacturerImages($manufacturer_id);
        }
        else
        {
            if(trim($data['img_name']) != '' && intval($fileinfo['size']) == 0){
                require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce'.DS.'classes'.DS.'CrBcImage.php');
                CrBcImage::renameManufacturerImage(trim($data['img_name']), $manufacturer_id);
            }
        }

        return true;
    }

    function delete()
    {
        $cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
        JArrayHelper::toInteger($cids);
        $row = $this->getTable();

        foreach($cids as $cid) {
            if (!$row->delete( $cid )) {
                $this->setError( $row->getErrorMsg() );
                return false;
            }
            else{
                $this->_db->setQuery("Delete From #__breezingcommerce_product_manufacturers Where manufacturer_id = " . $cid);
                $this->_db->query();
                
                $this->_db->setQuery("Delete From #__breezingcommerce_translations Where type = 'manufacturer' And item_id = " . $cid);
                $this->_db->query();
                
                $this->_db->setQuery("Delete From #__breezingcommerce_translations Where type = 'manufacturer_image' And item_id = " . $cid);
                $this->_db->query();
            }
        }

        $row->reorder();

        return true;
    }

    function move($direction) {

      $db = JFactory::getDBO();
      $mainframe = JFactory::getApplication();

      $row = $this->getTable('manufacturer');

      if (!$row->load($this->_id)) {
         $this->setError($db->getErrorMsg());
         return false;
      }

      if (!$row->move( $direction )) {
         $this->setError($db->getErrorMsg());
         return false;
      }

      return true;
   }
}
