<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

defined('_JEXEC') or die('Restricted access');
?>
<script type="text/javascript">
    function crbc_submitbutton(pressbutton)
    {
        switch (pressbutton) {
            case 'cancel':
                submitform(pressbutton);
                break;
            case 'save':
                var error = false;
                
                if( document.getElementById('name').value == '' )
                {
                    error = true;
                    alert("<?php echo addslashes( JText::_('COM_BREEZINGCOMMERCE_ALERT_ERROR_CURRECNY_NAME') ) ;?>");
                }

                if( document.getElementById('code').value == '' )
                {
                    error = true;
                    alert("<?php echo addslashes( JText::_('COM_BREEZINGCOMMERCE_ALERT_ERROR_CURRECNY_CODE') ) ;?>");
                }

                if( document.getElementById('symbol').value == '' )
                {
                    error = true;
                    alert("<?php echo addslashes( JText::_('COM_BREEZINGCOMMERCE_ALERT_ERROR_CURRECNY_SYMBOL') ) ;?>");
                }

                if( isNaN( document.getElementById('conversion_rate').value ) )
                {
                    error = true;
                    alert("<?php echo addslashes( JText::_('COM_BREEZINGCOMMERCE_ALERT_ERROR_CONVERSION_RATE') ) ;?>");
                }

                if(!error)
                {
                    submitform(pressbutton);
                }
                
                break;
        }
    }


    // Joomla 1.6 compat
    if(typeof Joomla != 'undefined'){
        Joomla.submitbutton = crbc_submitbutton;
    }
    // Joomla 1.5 compat
    submitbutton = crbc_submitbutton;
</script>
<form action="index.php" method="post" name="adminForm" id="adminForm">
    
    <div class="form-horizontal">
        
        <?php
        // translations
        if(JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','') != ''){

            $pane2 = new CrBcPane();
            echo $pane2->initPane(
                array(
                    'translation-pane' => htmlentities(JFactory::getSession()->get('com_breezingcommerce.selected_backend_language_title',''), ENT_QUOTES, 'UTF-8' ),
                    'original-pane' => JText::_( 'COM_BREEZINGCOMMERCE_DEFAULT_LANGUAGE' )
                )
            );

            echo $pane2->startPane();
            echo $pane2->startPanel( 'translation-pane' );
        ?>
        
        <div class="control-group">
            <div class="control-label">
                <label for="name_translation" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_CURRENCY_NAME_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_NAME' ); ?></label>
            </div>
            <div class="controls">
                <input type="text" name="name_translation" id="name_translation" maxlength="250" value="<?php echo htmlentities( $this->currency->name_translation, ENT_QUOTES, 'UTF-8');?>" />
            </div>
        </div>
        
        <?php
            echo $pane2->endPanel();
            echo $pane2->startPanel( 'original-pane' );
        }

        // default (all) case
        ?>
        
        <div class="control-group">
            <div class="control-label">
                <label for="name" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_CURRENCY_NAME_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_NAME' ); ?></label>
            </div>
            <div class="controls">
                <input type="text" name="name" id="name" maxlength="250" value="<?php echo htmlentities( $this->currency->name, ENT_QUOTES, 'UTF-8');?>" />
            </div>
        </div>
        
        <?php
        if(JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','')){
            echo $pane2->endPanel();
            echo $pane2->endPane();
        }
        // translations end
        ?>
        
        <div class="control-group">
            <div class="control-label">
                <label for="code" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_CURRENCY_CODE_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_CODE' ); ?></label>
            </div>
            <div class="controls">
                <input type="text" name="code" id="code" maxlength="250" value="<?php echo htmlentities( $this->currency->code, ENT_QUOTES, 'UTF-8');?>" />
            </div>
        </div>
        
        <div class="control-group">
            <div class="control-label">
                <label for="symbol" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_CURRENCY_SYMBOL_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_SYMBOL' ); ?></label>
            </div>
            <div class="controls">
                <input type="text" name="symbol" id="symbol" maxlength="250" value="<?php echo htmlentities( $this->currency->symbol, ENT_QUOTES, 'UTF-8');?>" />
            </div>
        </div>
        
        <div class="control-group">
            <div class="control-label">
                <label for="conversion_rate" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_CURRENCY_CONVERSION_RATE_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_CONVERSION_RATE' ); ?></label>
            </div>
            <div class="controls">
                <input type="text" name="conversion_rate" id="conversion_rate" maxlength="69" value="<?php echo htmlentities( $this->currency->conversion_rate, ENT_QUOTES, 'UTF-8');?>" />
            </div>
        </div>
        
    </div>

<div class="ct-clear"></div>

<input type="hidden" name="option" value="com_breezingcommerce" />
<input type="hidden" name="id" value="<?php echo $this->currency->id; ?>" />
<input type="hidden" name="cid[]" value="<?php echo $this->currency->id; ?>" />
<input type="hidden" name="task" value="" />
<input type="hidden" name="controller" value="currencies" />
<input type="hidden" name="default" value="<?php echo $this->currency->default ;?>" />
<input type="hidden" name="ordering" value="<?php echo $this->currency->ordering ;?>" />
<input type="hidden" name="published" value="<?php echo $this->currency->published ;?>" />
</form>


