<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

defined('_JEXEC') or die('Restricted access');
?>
<script type="text/javascript">
    function crbc_submitbutton(pressbutton)
    {
        switch (pressbutton) {
            case 'cancel':
                submitform(pressbutton);
                break;
            case 'save':
                var error = false;

                if( document.getElementById('name').value == '' )
                {
                    error = true;
                    alert("<?php echo addslashes( JText::_('COM_BREEZINGCOMMERCE_ALERT_ERROR_CUSTOMERGROUP_NAME') ) ;?>");
                }else
                if(document.adminForm.country_id.selectedIndex == -1 || document.adminForm.country_id.options[document.adminForm.country_id.selectedIndex].value == ""){
                    error = true;
                    alert("<?php echo addslashes(JText::_('COM_BREEZINGCOMMERCE_ALERT_ERROR_CUSTOMER_COUNTRY'));?>");
                }else
                if( isNaN(document.getElementById('off_percent').value) )
                {
                    error = true;
                    alert("<?php echo addslashes( JText::_('COM_BREEZINGCOMMERCE_ALERT_ERROR_DISCOUNT_PERCENT') ) ;?>");
                }

                if(!error)
                {
                    submitform(pressbutton);
                }

                break;
        }
    }

    // Joomla 1.6 compat
    if(typeof Joomla != 'undefined'){
        Joomla.submitbutton = crbc_submitbutton;
    }
    // Joomla 1.5 compat
    submitbutton = crbc_submitbutton;
</script>
<form action="index.php" method="post" name="adminForm" id="adminForm">


    <div class="form-horizontal">

        <div class="control-group">
            <div class="control-label">
                <label for="name" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_CUSTOMER_GROUP_DETAILS_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_DETAILS' ); ?></label>
            </div>
            <div class="controls">
                <input type="text" name="name" id="name" maxlength="250" value="<?php echo htmlentities( $this->item->name, ENT_QUOTES, 'UTF-8');?>" />
            </div>
        </div>

        <div class="control-group">
            <div class="control-label">
                <label for="country_id" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_CUSTOMER_GROUP_DEFAULT_COUNTRY_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_DEFAULT_COUNTRY' ); ?></label>
            </div>
            <div class="controls">
                <select class='chzn-done' name="default_country_id" id="country_id" onchange="crbcSwitchCountry()">
                    <option value=""><?php echo JText::_('COM_BREEZINGCOMMERCE_SELECT_ONE');?></option>
                    <?php
                    foreach($this->item->countries As $country){
                    ?>
                    <option value="<?php echo $country->id;?>"<?php echo $country->id == $this->item->default_country_id ? ' selected="selected"': '' ?>><?php echo htmlentities( $country->name, ENT_QUOTES, 'UTF-8');?></option>
                    <?php
                    }
                    ?>
                </select>
            </div>
        </div>

        <div class="control-group">
            <div class="control-label">
                <label for="region_id" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_CUSTOMER_GROUP_DEFAULT_REGION_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_DEFAULT_REGION' ); ?></label>
            </div>
            <div class="controls">
                <select class="chzn-done" name="default_region_id" id="region_id">
                    <option value="0">*</option>
                </select>
                <script type="text/javascript">
                <!--
                countries = new Array();
                <?php
                foreach($this->item->countries As $country){
                    $regions = '';
                    $size = count($country->regions);
                    $i = 0;
                    foreach($country->regions As $region){
                        $regions .= '{';
                        $regions .= 'name: "'.addslashes($region->name).'", code: "'.addslashes($region->code).'", id: '.$region->id.'';
                        $regions .= '}';
                        if($i + 1 < $size){
                            $regions .= ',';
                        }
                        $i++;
                    }

                    echo 'countries.push({country_id : "'.addslashes($country->id).'", regions: ['.$regions.']});'."\n";
                }
                ?>
                var countrySelected = document.adminForm.country_id.selectedIndex != -1 ? document.adminForm.country_id.options[document.adminForm.country_id.selectedIndex].value : 0;
                var regionSelected  = <?php echo $this->item->default_region_id ? $this->item->default_region_id: 0?>;
                crbcSwitchRegion(countrySelected, regionSelected);
                //-->
                </script>
            </div>
        </div>

        <div class="control-group">
            <div class="control-label">
                <label for="tax_class_id" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_CUSTOMER_GROUP_TAX_CLASS_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_TAX_CLASS' ); ?></label>
            </div>
            <div class="controls">

                <select class="chzn-done" name="tax_class_id" id="tax_class_id">
                    <option value="0"><?php echo JText::_('COM_BREEZINGCOMMERCE_NONE');?></option>
                    <?php
                    foreach($this->item->taxclasses As $taxclass) {
                        echo '<option value="'.$taxclass->id.'"'.($taxclass->selected ? ' selected="selected"' : '').'>'.htmlentities($taxclass->name, ENT_QUOTES, 'UTF-8').'</option>'."\n";
                    }
                    ?>
                </select>

            </div>
        </div>

        <div class="control-group">
            <div class="control-label">
                <label for="off_percent" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_CUSTOMER_GROUP_DISCOUNTPERCENT_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_CUSTOMER_GROUP_DISCOUNTPERCENT' ); ?></label>
            </div>
            <div class="controls">
                <input type="text" name="off_percent" id="off_percent" maxlength="250" value="<?php echo htmlentities( $this->item->off_percent, ENT_QUOTES, 'UTF-8');?>" />
            </div>
        </div>

        <div class="control-group">
            <div class="control-label">
                <label for="currency_id" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_CUSTOMER_GROUP_FORCE_CURRENCY_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_FORCE_CURRENCY' ); ?></label>
            </div>
            <div class="controls">

                <select class="chzn-done" name="currency_id" id="currency_id">
                    <option value="0"><?php echo JText::_('COM_BREEZINGCOMMERCE_NONE');?></option>
                    <?php
                    foreach($this->item->currencies As $currency) {
                        echo '<option value="'.$currency->id.'"'.($currency->selected ? ' selected="selected"' : '').'>'.htmlentities($currency->name, ENT_QUOTES, 'UTF-8').' ('.htmlentities($currency->code, ENT_QUOTES, 'UTF-8').', '.htmlentities($currency->symbol, ENT_QUOTES, 'UTF-8').')</option>'."\n";
                    }
                    ?>
                </select>

            </div>
        </div>

        <div class="control-group">
            <div class="control-label">
                <label for="tax_on_base_price" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_CUSTOMER_GROUP_TAX_ON_BASE_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_CUSTOMER_GROUP_TAX_ON_BASE' ); ?></label>
            </div>
            <div class="controls">
                <input type="radio" name="tax_on_base_price" id="tax_on_base_price" value="1"<?php echo isset($this->item->tax_on_base_price) && $this->item->tax_on_base_price ? ' checked="checked"' : '' ?>/>
                <label for="tax_on_base_price"><?php echo JText::_('COM_BREEZINGCOMMERCE_YES');?></label>
                <input type="radio" name="tax_on_base_price" id="file_verification_1" value="0" <?php echo  isset($this->item->tax_on_base_price) && !$this->item->tax_on_base_price ? ' checked="checked"' : '' ?>/>
                <label for="tax_on_base_price_2"><?php echo JText::_('COM_BREEZINGCOMMERCE_NO');?></label>

            </div>
        </div>

    </div>

<div class="ct-clear"></div>

<input type="hidden" name="option" value="com_breezingcommerce" />
<input type="hidden" name="id" value="<?php echo $this->item->id; ?>" />
<input type="hidden" name="cid[]" value="<?php echo $this->item->id; ?>" />
<input type="hidden" name="task" value="" />
<input type="hidden" name="controller" value="customergroups" />
<input type="hidden" name="default" value="<?php echo $this->item->default ;?>" />
<input type="hidden" name="ordering" value="<?php echo $this->item->ordering ;?>" />
<input type="hidden" name="published" value="<?php echo $this->item->published ;?>" />
</form>
