<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/

defined('_JEXEC') or die('Restricted access');
?>
<script type="text/javascript">
    function crbc_submitbutton(pressbutton)
    {
        switch (pressbutton) {
            case 'cancel':
                submitform(pressbutton);
                break;
            case 'save':
                var error = false;

                if(document.getElementById("name").value == ""){
                    error = true;
                    alert("<?php echo addslashes(JText::_('COM_BREEZINGCOMMERCE_ALERT_ERROR_TAXES_RULE_NAME'));?>");
                }
                else if(isNaN(document.getElementById("priority").value)){
                    error = true;
                    alert("<?php echo addslashes(JText::_('COM_BREEZINGCOMMERCE_ALERT_ERROR_TAXES_RULE_PRIORITY'));?>");
                }

                if(!error)
                {
                    submitform(pressbutton);
                }
                
                break;
        }
    }

    // Joomla 1.6 compat
    if(typeof Joomla != 'undefined'){
        Joomla.submitbutton = crbc_submitbutton;
    }
    // Joomla 1.5 compat
    submitbutton = crbc_submitbutton;
</script>
<form action="index.php" method="post" name="adminForm" id="adminForm">
    
    <div class="form-horizontal">
        
        <?php
        // translations
        if(JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','') != ''){

            $pane2 = new CrBcPane();
            echo $pane2->initPane(
                array(
                    'translation-name-pane' => htmlentities(JFactory::getSession()->get('com_breezingcommerce.selected_backend_language_title',''), ENT_QUOTES, 'UTF-8' ),
                    'original-name-pane' => JText::_( 'COM_BREEZINGCOMMERCE_DEFAULT_LANGUAGE' )
                )
            );

            echo $pane2->startPane();
            echo $pane2->startPanel( 'translation-name-pane' );
        ?>
        
        <div class="control-group">
            <div class="control-label">
                <label for="name_translation" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_TAX_RULE_NAME_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_NAME' ); ?></label>
            </div>
            <div class="controls">
                <input type="text" name="name_translation" id="name_translation" maxlength="250" value="<?php echo htmlentities( $this->taxrule->name_translation, ENT_QUOTES, 'UTF-8');?>" />
            </div>
        </div>
        
        <?php
            echo $pane2->endPanel();
            echo $pane2->startPanel( 'original-name-pane' );
        }
        // default (all) case
        ?>
        
        <div class="control-group">
            <div class="control-label">
                <label for="name" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_TAX_RULE_NAME_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_NAME' ); ?></label>
            </div>
            <div class="controls">
                <input type="text" name="name" id="name" maxlength="250" value="<?php echo htmlentities( $this->taxrule->name, ENT_QUOTES, 'UTF-8');?>" />
            </div>
        </div>
        
        <?php
        if(JFactory::getSession()->get('com_breezingcommerce.selected_backend_language','')){
            echo $pane2->endPanel();
            echo $pane2->endPane();
        }
        // translations end
        ?>
        
        <div class="control-group">
            <div class="control-label">
                <label for="customertaxclasses" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_TAX_RULE_CUSTOMER_TAX_CLASSES_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_CUSTOMER_TAX_CLASSES' ); ?></label>
            </div>
            <div class="controls">
                    <select class="chzn-done" style="height: 100px;" multiple="multiple" name="customertaxclasses[]" id="customertaxclasses">
                    <?php
                    foreach($this->taxrule->customertaxclasses As $customertaxclass){
                    ?>
                    <option value="<?php echo $customertaxclass->id;?>"<?php echo $customertaxclass->selected  ? ' selected="selected"': '' ?>><?php echo htmlentities( $customertaxclass->name, ENT_QUOTES, 'UTF-8');?></option>
                    <?php
                    }
                    ?>
                </select>
            </div>
        </div>
        
        <div class="control-group">
            <div class="control-label">
                <label for="producttaxclasses" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_TAX_RULE_PRODUCT_TAX_CLASSES_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRODUCT_TAX_CLASSES' ); ?></label>
            </div>
            <div class="controls">
                
                <select class="chzn-done" style="height: 100px;" multiple="multiple" name="producttaxclasses[]" id="producttaxclasses">
                    <?php
                    foreach($this->taxrule->producttaxclasses As $producttaxclass){
                    ?>
                    <option value="<?php echo $producttaxclass->id;?>"<?php echo $producttaxclass->selected  ? ' selected="selected"': '' ?>><?php echo htmlentities( $producttaxclass->name, ENT_QUOTES, 'UTF-8');?></option>
                    <?php
                    }
                    ?>
                </select>
                
            </div>
        </div>
        
        <div class="control-group">
            <div class="control-label">
                <label for="taxrates" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_TAX_RULE_TAXRATES_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_TAXRATES' ); ?></label>
            </div>
            <div class="controls">
                <select class="chzn-done" style="height: 100px;" multiple="multiple" name="taxrates[]" id="taxrates">
                    <?php
                    foreach($this->taxrule->taxrates As $taxrate){
                    ?>
                    <option value="<?php echo $taxrate->id;?>"<?php echo $taxrate->selected  ? ' selected="selected"': '' ?>><?php echo htmlentities( $taxrate->name, ENT_QUOTES, 'UTF-8');?></option>
                    <?php
                    }
                    ?>
                </select>
            </div>
        </div>
        
        <div class="control-group">
            <div class="control-label">
                <label for="priority" class="tip-top hasTooltip" title="<?php echo JHtml::tooltipText( 'COM_BREEZINGCOMMERCE_TAX_RULE_PRIORITY_TIP' ); ?>"><?php echo JText::_( 'COM_BREEZINGCOMMERCE_PRIORITY' ); ?></label>
            </div>
            <div class="controls">
                    <input type="text" name="priority" id="priority" maxlength="250" value="<?php echo htmlentities( $this->taxrule->priority, ENT_QUOTES, 'UTF-8');?>" />
            </div>
        </div>
        
    </div>

<div class="ct-clear"></div>

<input type="hidden" name="option" value="com_breezingcommerce" />
<input type="hidden" name="id" value="<?php echo $this->taxrule->id; ?>" />
<input type="hidden" name="cid[]" value="<?php echo $this->taxrule->id; ?>" />
<input type="hidden" name="task" value="" />
<input type="hidden" name="controller" value="taxrules" />
<input type="hidden" name="ordering" value="<?php echo $this->taxrule->ordering ;?>" />
<input type="hidden" name="published" value="<?php echo $this->taxrule->published ;?>" />
</form>


