<?php
/**
 * @package     BreezingCommerce
 * @author      Markus Bopp
 * @link        http://www.crosstec.de
 * @license     GNU/GPL
*/
defined( '_JEXEC' ) or die( 'Restricted access' );

$libpath = JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_breezingcommerce' . DS . 'classes' . DS . 'plugin' . DS;
require_once($libpath . 'CrBcAProductimagesSitePlugin.php');
require_once($libpath . 'CrBcProductimagesSitePlugin.php');

class CrBc_Plugins_Productimages_Zoom_Site extends CrBcAProductimagesSitePlugin implements CrBcProductimagesSitePlugin
{
    
    private $product_id = 0;
    
    public function  __construct() {
        
        parent::__construct();
    }
    
    function init($product_id = null){
        if($product_id !== null){
            $this->product_id = $product_id;
        }
    }

    /**
     * Called on render HTML
     */
    function display(){
        
        CrBcHelpers::addCssFile(JUri::root(true).'/media/breezingcommerce/plugins/productimages/zoom/site/js/elastislide/elastislide.css');
        CrBcHelpers::addCssFile(JUri::root(true).'/media/breezingcommerce/plugins/productimages/zoom/site/js/elastislide/theme.css');
        JFactory::getDocument()->addScript(JUri::root(true).'/media/breezingcommerce/plugins/productimages/zoom/site/js/elastislide/modernizr.custom.17475.js');
        JFactory::getDocument()->addScript(JUri::root(true).'/media/breezingcommerce/plugins/productimages/zoom/site/js/elastislide/jqpp.custom.js');
        JFactory::getDocument()->addScript(JUri::root(true).'/media/breezingcommerce/plugins/productimages/zoom/site/js/elastislide/jq.elastislide.js');
        JFactory::getDocument()->addScript(JUri::root(true).'/media/breezingcommerce/plugins/productimages/zoom/site/js/zoomsl/zoomsl-3.0.js');
        
        $this->template = 'details';
        
        $db = JFactory::getDBO();
        $db->setQuery("Select * From #__breezingcommerce_images Where `product_id` = " . $db->Quote($this->product_id) . " And published = 1 Order By ordering");
        $rows = $db->loadObjectList();
        
        $assignments = array(
            'title' => 'alt_name', 
            'body' => 'description'
        );
        
        foreach($rows As $row){
            CrBcHelpers::assignTranslation($assignments, $row, $row->id, 'product_image');
        }
        
        $this->assignRef('images', $rows);
        
    }

    public function getPluginDisplayName(){
        return JText::_('Images Zoom');
    }
}
